VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public tv As New TrueVision8 'The main object
Public TexFactory As New TextureFactory8 'This object helps you easily load textures by
' defining the path to the texture and a name for the texture. Then this texture can be
'called with the function    GetTex "Name"
Public Land As New Landscape8 'This is the landscape, you set some properties for it
' and then rendering it
Public Scene As New Scene8 ' :=screen
Public Inp As New InputEngine8 ' the input engine is used to determine
' which keys are pressed

Dim x As Single, y As Single, z As Single, ang As Single ' Our position

Private Sub Form_Load()
Dim b As Integer
tv.ShowDriverDialog 'Let the user make his options...

tv.Initialize 'and then load based on them

TexFactory.LoadTexture App.Path + "\tex.bmp", "TerrainTex" 'see decleration
Scene.SetSceneBackGround 0.1, 0.3, 0.5 'where there is nothing this color will be shown
' colors are in a strange system here so what in windows is 255 here is 1. So 245 in
' the TV color system is 245 / 255

Land.SetFactorY 0.2 'Defines how much steep the mountains will be

Land.GenerateTerrain App.Path + "\height.jpg", TV_PRECISION_HIGH, 0, 0 ' The first
 ' defines the file where the height map is. The second defines how much percise will
 ' be based on the height map The 0, 0 defines the starting position
 
Land.GenerateTerrain App.Path + "\height.jpg", TV_PRECISION_HIGH, 255, 0
Land.GenerateTerrain App.Path + "\height.jpg", TV_PRECISION_HIGH, 0, 255
Land.GenerateTerrain App.Path + "\height.jpg", TV_PRECISION_HIGH, 255, 255
Land.SetTexture GetTex("Terraintex") 'Call the named texture
 
 


Do 'Start main loop

tv.Clear 'Clear the screen
Land.Render 'Render the landscape with the option made
tv.RenderToScreen 'Finally transfer the rendered landscape to the screen

If Inp.IsKeyPressed(TV_KEY_1) = True Then 'Check if the key '1' is pressed
Scene.SetRenderMode TV_LINE ' Then set the line viewmode
End If

If Inp.IsKeyPressed(TV_KEY_2) = True Then
Scene.SetRenderMode TV_POINT
End If
If Inp.IsKeyPressed(TV_KEY_3) = True Then
Scene.SetRenderMode TV_SOLID
End If


If Inp.IsKeyPressed(TV_KEY_UP) = True Then
x = x + Cos(ang) * tv.TimeElapsed * 0.05 ' Set our position
z = z + Sin(ang) * tv.TimeElapsed * 0.05 ' Set our position
End If
If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then
x = x - Cos(ang) * tv.TimeElapsed * 0.05 ' Set our position
z = z - Sin(ang) * tv.TimeElapsed * 0.05 ' Set our position
End If
If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
ang = ang + tv.TimeElapsed * 0.005
End If
If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
ang = ang - tv.TimeElapsed * 0.005
End If

y = Land.GetHeight(x, z) + 10 'Detect how much high the landscape is, on a
'certain position (x, z) and add 10 more to be sure. All these is our 'Y'

Scene.SetCamera x, y, z, x + Cos(ang), y, z + Sin(ang) 'Finally set the camera
' to view the position we are: x,y,z

Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True
End
End Sub
